//+------------------------------------------------------------------+
//|                                            AverageVolatility.mq4 |
//|                                                         basefree |
//|                                             jmcguire90@gmail.com |
//+------------------------------------------------------------------+
#property copyright "basefree"
#property link      "jmcguire90@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_color2 Blue



extern string Primary   =  "AUDJPY"; // AUDJPYFXF
extern string Secondary =  "NZDJPY"; //NZDJPYFXF
extern int    cPeriod   =  20;
double AverageVolatility[];
double cBuffer[];
int ExtCountedBars   =  0;
 double RATIO ;
 
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AverageVolatility);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,cBuffer);   
   
   IndicatorShortName("AverageVolatility");
   SetIndexLabel(0,"AV");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int   counted_bars=IndicatorCounted();
   int   limit;
   if(counted_bars>0)   counted_bars--;
   limit =  Bars  -  counted_bars;
   for(int i=0;i<limit;i++){
      double pBBU =  iBands(Primary,0,20,2,0,PRICE_CLOSE,MODE_UPPER,i);
      double pBBL =  iBands(Primary,0,20,2,0,PRICE_CLOSE,MODE_LOWER,i);
      double sBBU =  iBands(Secondary,0,20,2,0,PRICE_CLOSE,MODE_UPPER,i);
      double sBBL =  iBands(Secondary,0,20,2,0,PRICE_CLOSE,MODE_LOWER,i);
      double pDIFF   =  pBBU  -  pBBL;
      double sDIFF   =  sBBU  -  sBBL;
      
      if(sDIFF != 0) { RATIO   =  pDIFF /  sDIFF; } else { RATIO   =  0.0 ; }
       
      cBuffer[i]  =  RATIO;
   }
   
   for(int j=0;j<limit;j++){
//      AverageVolatility[i] =  iMAOnArray(cBuffer,0,cPeriod,0,MODE_EMA,0);
      AverageVolatility[j] =  iMAOnArray(cBuffer,Bars,cPeriod,0,MODE_EMA,j);
      
      
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+