//+------------------------------------------------------------------+ 
//|   TRO_MFI                                                        | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_separate_window

 
#property indicator_buffers 3

extern bool   Sound.Alert    = true ;
extern bool   Send.Mail      = false ; 
extern bool   Show.Commemt   = false ;
extern bool   Show.Legend    = true ; 


//---- input parameters
extern int iMFIPeriod    = 5; 
extern int iNumBars      = 1000 ;
extern int iMaxThreshold = 80 ;
extern int iMinThreshold = 20 ;

extern color myColor = DimGray ;

//---- buffers
double ExtMFIBuffer[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

double minpips = 99999, maxpips = -99999 , spread, diff, maxdiff=-999, mindiff=999;

string  sSpread, sOpen, sPrice, sHigh, sLow, sPct, sMinDateTime, sMaxDateTime ; 
int      cd, cd1, cd2, BarsBack1, BarsBack2, minbar, maxbar ;


string TAG, symbol, tChartPeriod,  tShortName, trademsg ;   
  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos  ;  
 
double    point , maxpct, minpct ;
int MaxThresholdCount = 0 ;
int MinThresholdCount = 0, BarsInStudy ;
  
//+------------------------------------------------------------------+
int   CrossUp, CrossDn  ;  
  
bool  bCrossUp, bCrossDn ; 
   
string sShortName;

datetime Trigger ;   
//+------------------------------------------------------------------+
 
void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
     
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 
   TAG          = "mfi" ;

   tChartPeriod =  TimeFrameToString(period) ;  

//----
   SetIndexBuffer(0,ExtMFIBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 1, myColor );
//---- name for DataWindow and indicator subwindow label
   sShortName="MFI("+iMFIPeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,iMFIPeriod);
//----
   
   SetIndexBuffer( 1, ExtMapBuffer2 );
   SetIndexBuffer( 2, ExtMapBuffer3 );
 
   SetIndexStyle( 1, DRAW_LINE, 0, 1, Green );
   SetIndexStyle( 2, DRAW_LINE, 0, 1, Red );
 


   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,95 );
   SetLevelValue(2,90 );   
   SetLevelValue(3,80 );
   SetLevelValue(4,50);
   SetLevelValue(5,20 );
   SetLevelValue(6,10 );
   SetLevelValue(7,5 ); 
   return(0);
  }
 
//+------------------------------------------------------------------+ 
int deinit()
{  
   TRO() ;  
   Comment("");
   
   return(0);
}   
//+------------------------------------------------------------------+
int start()
  {
  

   win =    WindowFind(sShortName);
  
  
   int    i,j,nCountedBars;
   
//---- insufficient data
   if(Bars<=iMFIPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----
   i=Bars-iMFIPeriod-1;
   if(nCountedBars>iMFIPeriod) 
      i=Bars-nCountedBars-1;
      

maxdiff = -9999 ;
mindiff = 99999 ;      

MaxThresholdCount = 0 ;
MinThresholdCount = 0 ;
      
     
      
   if( iNumBars > 0 ) { i = iNumBars ; }  
    
   BarsInStudy =  i ; 
      
   while(i>=0)
     {
      
         ExtMFIBuffer[i] = iMFI(symbol,period,iMFIPeriod,i);      
      
    diff = ExtMFIBuffer[i] ;  
      
    if( diff > maxdiff ) { maxdiff = diff ; maxbar = i ;}
    if( diff < mindiff ) { mindiff = diff ; minbar = i ;}
    
    if( diff >= iMaxThreshold ) { MaxThresholdCount = MaxThresholdCount + 1 ;}
    if( diff <= iMinThreshold ) { MinThresholdCount = MinThresholdCount + 1 ;}
 

    ExtMapBuffer2[i] = maxdiff ;
    ExtMapBuffer3[i] = mindiff ;
      
      i--;
     }

 bCrossUp = false ;   
 bCrossDn = false ; 

CrossUp = -1 ;
CrossDn = -1 ; 

for( i=0; i<BarsInStudy ; i++ )
{
   if( ExtMFIBuffer[i] > 50 && ExtMFIBuffer[i+1] < 50 && !bCrossUp ) {bCrossUp = true ; CrossUp = i ;}
   if( ExtMFIBuffer[i] < 50 && ExtMFIBuffer[i+1] > 50 && !bCrossDn ) {bCrossDn = true ; CrossDn = i ;}
   if( bCrossUp && bCrossDn) { break ; }   
} 
      

  if ( Trigger != Time[0] ) 
  {
  if( Sound.Alert )
  {
        if( CrossUp == 0 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " MFI Cross above 50 "+ DoubleToStr(Close[0] ,digits)); }
        if( CrossDn == 0 ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " MFI Cross below 50 "+ DoubleToStr(Close[0] ,digits)); }     
  }
  
  if( Send.Mail )
  {
     if( CrossUp == 0 ) { Trigger = Time[0] ; SendMail(symbol,  tChartPeriod + " MFI Cross above 50 "); }
     if( CrossDn == 0 ) { Trigger = Time[0] ; SendMail(symbol,  tChartPeriod + " MFI Cross below 50 "); }     
  }  
 
  }
if(Show.Commemt )
{

maxpct = (100.0 * MaxThresholdCount) / BarsInStudy ;

minpct = (100.0 * MinThresholdCount) / BarsInStudy ;

Comment("\n", 
 
"MFI(" + iMFIPeriod  + ")= ", DoubleToStr( diff , 2), "\n",    
"Bars In Study  = ", BarsInStudy  , "\n",  

"MAX MFI = ", DoubleToStr( maxdiff , 2),  "\n",   
"MAX BAR# = ", maxbar ,  " | " ,DoubleToStr( maxpct , 2),  "%\n",    
"MAX Threshold ",iMaxThreshold ," Exceeded ", MaxThresholdCount  ," times" ,  "\n",   
"MIN MFI = ", DoubleToStr( mindiff , 2), "\n",    
"MIN BAR# = ", minbar , " | " ,DoubleToStr( minpct , 2),  "%\n",    
"MIN Threshold ",iMinThreshold ," Exceeded ",  MinThresholdCount ," times" , "\n",    
"") ;    
   
}// if

 
    if(Show.Legend) { DoShowLegend(); }   
          
    WindowRedraw() ; 
   return(0);
}

//+------------------------------------------------------------------+  
void DoShowLegend()
{ 

   ObDeleteObjectsByPrefix(TAG);
   int yInc , yAdd ;

   yInc = 12 ; 
   yAdd = 13;

   setObject(TAG+"ss",symbol + "[" + BarsInStudy +"]   "   ,50,yInc, myColor ); 
   setObject(TAG+"ss1",DoubleToStr(Close[0],digits) ,11,yInc,myColor     ,"Courier New");

   yInc = yInc + yAdd;    
   setObject(TAG+"va","MFI("+iMFIPeriod+") =      " ,50,yInc, myColor );     
   setObject(TAG+"va1",DoubleToStr(ExtMFIBuffer[0],4) ,11,yInc,myColor     ,"Courier New");
   
   yInc = yInc + yAdd;    
   setObject(TAG+"up","Cross Above 50 " ,50,yInc, myColor ); 
   yInc = yInc + yAdd;      
   setObject(TAG+"up1",TimeToStr(Time[CrossUp]) ,11,yInc,myColor     ,"Courier New");
   
   yInc = yInc + yAdd;      
   setObject(TAG+"dn","Cross Below 50 " ,50,yInc, myColor); 
   yInc = yInc + yAdd;      
   setObject(TAG+"dn1",TimeToStr(Time[CrossDn]) ,11,yInc,myColor     ,"Courier New");
   
   yInc = yInc + yAdd; 
   setObject(TAG+"MX","Max Value      " ,50,yInc, myColor); setObject(TAG+"mx1",DoubleToStr( maxdiff , 4) ,11,yInc,myColor     ,"Courier New");

   yInc = yInc + yAdd; 
   //setObject(TAG+"Md","Maximum Date   " ,50,yInc, myColor); 
   setObject(TAG+"md1",TimeToStr(Time[maxbar]) ,11,yInc,myColor     ,"Courier New");

   yInc = yInc + yAdd; 
   setObject(TAG+"nX","Min Value      " ,50,yInc, myColor); setObject(TAG+"nx1",DoubleToStr( mindiff , 4) ,11,yInc,myColor     ,"Courier New");

   yInc = yInc + yAdd; 
   //setObject(TAG+"Md","Maximum Date   " ,50,yInc, myColor); 
   setObject(TAG+"nd1",TimeToStr(Time[minbar]) ,11,yInc,myColor     ,"Courier New");
     
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
   