//+------------------------------------------------------------------+ 
//|   TRO_BATTLE_ZONES                                               | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
 
 

extern bool   Show.Boxes  = true ;
extern bool   Show.H1  = true ;
extern bool   Show.D1  = false ;
extern bool   Show.W1  = false ;

extern bool   Show.Labels = true ;



extern int    ShiftLabel  =  20 ;


 
extern int myShift  = 1 ;
 
 

extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;

extern int    Line_Style_W1    = STYLE_SOLID ;
extern int    Line_Width_W1    = 2 ;

  
extern color  Line_Color_Hi        = Red ;
 
extern color  Line_Color_Lo        = DodgerBlue ;
extern color  Line_Color_Open      = Chocolate ;
extern color  Line_Color_Close     = Indigo ;


extern color COLOR_H1_ZONE   = MintCream ;//MintCream  PowderBlue

extern color COLOR_D1_ZONE   = AliceBlue ;//MintCream  PowderBlue
 
extern color COLOR_W1_ZONE   = WhiteSmoke  ; // DarkGray
 

 


string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName , TAG , text;  

int    digits, period, win, BarShift ; 

double point ;

double    HHprice, LLprice, TRIGGER, HHtrigger, LLtrigger, D1_Open, W1_Open, W1_High, W1_Low,  D1_pMid, D1_Close ;
datetime DateTime ; 
   
double  W1_Close,W1_pivot,D1_pivot, D1_high, D1_low , D1_ATR , W1_ATR, VALUE , D1Threshold , W1Threshold, ATRThreshold ;      
double  TOP, BOTTOM, TOPL, BOTTOML ;
double  H1_Close, H1_Open, H1_High, H1_Low;

//+------------------------------------------------------------------+

int init()
{
   period = Period() ; 

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troTL" ;
   ShortName    =  TAG+symbol+period   ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   

   ObDeleteObjectsByPrefix(TAG);   
  
   TRO() ;
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

deinit();
 
n       = 10;
j       = 0 ;


if(Show.H1)
{
H1_Open  = iOpen(symbol,PERIOD_H1,myShift);  
H1_Close = iClose(symbol,PERIOD_H1,myShift);  
H1_High  = iHigh(symbol,PERIOD_H1,myShift);
H1_Low   = iLow(symbol,PERIOD_H1,myShift);

if( H1_Close > H1_Open ) { TOP = H1_High; BOTTOM = H1_Close ;  TOPL = H1_Open; BOTTOML = H1_Low ; } 
else { TOP = H1_Close; BOTTOM = H1_Low ; TOPL = H1_High; BOTTOML = H1_Open ;} 

DateTime  = iTime(symbol,PERIOD_H1,myShift) ; 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(H1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Hourly Open["+myShift+"]" ) ; 
 

H1_Open = iOpen(symbol,PERIOD_H1,0);    
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(H1_Low ,lbl[j], Line_Color_Lo , Line_Style , Line_Width, DateTime, "Hourly Low["+myShift+"]" ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(H1_High ,lbl[j], Line_Color_Hi , Line_Style , Line_Width, DateTime, "Hourly High["+myShift+"]"   ) ;

DateTime  = iTime(symbol,PERIOD_H1,0) ; 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(H1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Hourly Open" ) ; 
 
//j       = j + 1 ;
//lbl[j]  = ShortName+j;
//drawLine(H1_Close ,lbl[j], Line_Color_Close , Line_Style , Line_Width, DateTime, "Hourly Close" ) ;  

        if (ObjectFind(ShortName+"69") != 0)
        ObjectCreate(ShortName+"69", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"69", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"69", OBJPROP_PRICE1, TOP);
        ObjectSet(ShortName+"69", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"69", OBJPROP_PRICE2, BOTTOM);
        ObjectSet(ShortName+"69", OBJPROP_COLOR, COLOR_H1_ZONE);
        ObjectSet(ShortName+"69", OBJPROP_BACK, true);

        if (ObjectFind(ShortName+"6a") != 0)
        ObjectCreate(ShortName+"6a", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"6a", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"6a", OBJPROP_PRICE1, TOPL);
        ObjectSet(ShortName+"6a", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"6a", OBJPROP_PRICE2, BOTTOML);
        ObjectSet(ShortName+"6a", OBJPROP_COLOR, COLOR_H1_ZONE);
        ObjectSet(ShortName+"6a", OBJPROP_BACK, true);
}  
    
if(Show.D1)  
{
D1_Open  = iOpen(symbol,PERIOD_D1,myShift);  
D1_Close = iClose(symbol,PERIOD_D1,myShift);  
D1_high  = iHigh(symbol,PERIOD_D1,myShift);
D1_low   = iLow(symbol,PERIOD_D1,myShift);

if( D1_Close > D1_Open ) { TOP = D1_high; BOTTOM = D1_Close ;  TOPL = D1_Open; BOTTOML = D1_low ; } 
else { TOP = D1_Close; BOTTOM = D1_low ; TOPL = D1_high; BOTTOML = D1_Open ;} 

DateTime  = iTime(symbol,PERIOD_D1,myShift) ; 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Daily Open["+myShift+"]" ) ; 
 

D1_Open = iOpen(symbol,PERIOD_D1,0);    
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_low ,lbl[j], Line_Color_Lo , Line_Style , Line_Width, DateTime, "Daily Low["+myShift+"]" ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_high ,lbl[j], Line_Color_Hi , Line_Style , Line_Width, DateTime, "Daily High["+myShift+"]"   ) ;

DateTime  = iTime(symbol,PERIOD_D1,0) ; 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, "Daily Open" ) ; 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(D1_Close ,lbl[j], Line_Color_Close , Line_Style , Line_Width, DateTime, "Daily Close" ) ;  

        if (ObjectFind(ShortName+"89") != 0)
        ObjectCreate(ShortName+"89", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"89", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"89", OBJPROP_PRICE1, TOP);
        ObjectSet(ShortName+"89", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"89", OBJPROP_PRICE2, BOTTOM);
        ObjectSet(ShortName+"89", OBJPROP_COLOR, COLOR_D1_ZONE);
        ObjectSet(ShortName+"89", OBJPROP_BACK, true);

        if (ObjectFind(ShortName+"8a") != 0)
        ObjectCreate(ShortName+"8a", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"8a", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"8a", OBJPROP_PRICE1, TOPL);
        ObjectSet(ShortName+"8a", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"8a", OBJPROP_PRICE2, BOTTOML);
        ObjectSet(ShortName+"8a", OBJPROP_COLOR, COLOR_D1_ZONE);
        ObjectSet(ShortName+"8a", OBJPROP_BACK, true);
  
}  
    
if(Show.W1)  
{ 

//DateTime  = iTime(symbol,PERIOD_W1,0) ;  
//BarShift  = iBarShift(symbol,PERIOD_W1,Time[0],true); 
W1_Open   = iOpen(symbol,PERIOD_W1,myShift); 
W1_Close  = iClose(symbol,PERIOD_W1,myShift); 
W1_High   = iHigh(symbol,PERIOD_W1,myShift); 
W1_Low    = iLow(symbol,PERIOD_W1,myShift); 
   
if( W1_Close > W1_Open ) { TOP = W1_High; BOTTOM = W1_Close ; TOPL = W1_Open; BOTTOML = W1_Low ;} 
else { TOP = W1_Close; BOTTOM = W1_Low ; TOPL = W1_High; BOTTOML = W1_Open ; }     
 
DateTime  = iTime(symbol,PERIOD_W1,0) ;  
BarShift  = iBarShift(symbol,PERIOD_W1,Time[0],true); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open   ,lbl[j], Line_Color_Open , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Open["+myShift+"]"    ) ;


W1_Open   = iOpen(symbol,PERIOD_W1,BarShift); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Close   ,lbl[j], Line_Color_Close, Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Close["+myShift+"]"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Open   ,lbl[j], Line_Color_Open , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Open"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_High   ,lbl[j], Line_Color_Hi , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly High["+myShift+"]"     ) ;
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(W1_Low   ,lbl[j], Line_Color_Lo , Line_Style_W1  , Line_Width_W1 , DateTime, "Weekly Low["+myShift+"]"     ) ;

      
        if (ObjectFind(ShortName+"81") != 0)
        ObjectCreate(ShortName+"81", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"81", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"81", OBJPROP_PRICE1, TOP );
        ObjectSet(ShortName+"81", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"81", OBJPROP_PRICE2, BOTTOM );
        ObjectSet(ShortName+"81", OBJPROP_COLOR, COLOR_W1_ZONE);
        ObjectSet(ShortName+"81", OBJPROP_BACK, true);
 
        if (ObjectFind(ShortName+"8b") != 0)
        ObjectCreate(ShortName+"8b", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"8b", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"8b", OBJPROP_PRICE1, TOPL );
        ObjectSet(ShortName+"8b", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"8b", OBJPROP_PRICE2, BOTTOML );
        ObjectSet(ShortName+"8b", OBJPROP_COLOR, COLOR_W1_ZONE);
        ObjectSet(ShortName+"8b", OBJPROP_BACK, true);        
}  
 
return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string text)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show.Labels)
   {         
      string Obj0002 = name+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      } // if 
                 
   } // if   

   if(Show.Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}
  

//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(D1_Open,Digits) , "\n" ,
"ATR " , DoubleToStr(D1_ATR,Digits) , "\n" , 
"\n" , 
"DailyOpen + ATR " , DoubleToStr(D1_Open + D1_ATR,Digits) , "\n" , 
"D1_high " , DoubleToStr(D1_high,Digits) , "\n" ,
"D1_low " , DoubleToStr(D1_low,Digits) , "\n" ,
"DailyOpen - ATR " , DoubleToStr(D1_Open - D1_ATR,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 

  
        if (ObjectFind(ShortName+"89") != 0)
        ObjectCreate(ShortName+"89", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"89", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"89", OBJPROP_PRICE1, TOP);
        ObjectSet(ShortName+"89", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"89", OBJPROP_PRICE2, BOTTOM);
        ObjectSet(ShortName+"89", OBJPROP_COLOR, COLOR_D1_ZONE);
        ObjectSet(ShortName+"89", OBJPROP_BACK, true); 
 
 */