//+------------------------------------------------------------------+ 
//|   TRO_MFI                                                        | 
//|                                                                  | 
//|   Copyright  2010, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2010, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

 
#property indicator_buffers 3

extern bool   Sound.Alert    = true ;
extern bool   Send.Mail      = false ; 
extern bool   Show.Commemt   = false ;
extern bool   Show.Legend    = true ; 


//---- input parameters
extern int    NumBoxes        = 24 ; 

extern color myColor1 = Gold ;
extern color myColor2 = Orange ;

//---- buffers
color myColor = Orange ;
  


string TAG, symbol, tChartPeriod,  tShortName, trademsg ;   
  
int    digits2, digits, period, win  ;  
 
double    point   ;
 
  
//+------------------------------------------------------------------+
 
  

double   MA_HIGH, MA_LOW   ;
 
double   H1, H2, L1, L2 ;    


//+------------------------------------------------------------------+
 
void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
     
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 
   TAG          = "mfi" ;

   tChartPeriod =  TimeFrameToString(period) ;  

 
   tShortName="H2L2BOX";
   IndicatorShortName(tShortName);
 
 
    
//----
    
  
 

 
   return(0);
  }
 
//+------------------------------------------------------------------+ 
int deinit()
{  
   TRO() ;  
   Comment("");
   
   return(0);
}   
//+------------------------------------------------------------------+
int start()
  {
   
  
  
   int    i,j,nCountedBars;
   
   
      i=NumBoxes ;
  
   while(i>=0)
     {
 
   H1 = iHigh(symbol,period,i+1) ;
   H2 = iHigh(symbol,period,i+2) ;
   L1 = iLow(symbol,period,i+1) ;
   L2 = iLow(symbol,period,i+2) ;


   
   MA_HIGH  = MathMax( H1 , H2 ); 
   MA_LOW   = MathMin( L1 , L2 );  
 
   
   if(myColor == myColor1) {myColor = myColor2 ;} else {myColor = myColor1 ;}
   
   
      
 PlaceRectangle( "S"+i,  "2-Bar Box["+i+"]",     Time[i],  MA_HIGH,  Time[i+1],  MA_LOW,  myColor,  myColor,  3) ;
 
      
      i--;
     }
 
          
    WindowRedraw() ; 
   return(0);
}

//+------------------------------------------------------------------+  
  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+    
void PlaceRectangle(string session, string description,   datetime time1, double price1, datetime time2, double price2, color session_color, color rect_color, int level)
{
//   if (time2 < time1 || time2 > time1 + 12*3600)
//      return;

bool BriefModeOn = false, SessionBordersOn = true ;
int Session_borders_line_style = 0, Session_borders_line_width = 1; 


   if (!BriefModeOn)
      double Y = WindowPriceMin(win) + (WindowPriceMax(win) - WindowPriceMin(win)) * (0.78 - level*0.15);
   else
      Y = WindowPriceMin(win) + (WindowPriceMax(win) - WindowPriceMin(win)) * (0.8 - level*0.2);
   
   if (SessionBordersOn)
   {
      //     
      
      string objname = session + " Session High";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price2, time2, price2);
      ObjectSet(objname, OBJPROP_COLOR, Magenta);
      ObjectSet(objname, OBJPROP_BACK, false);
      ObjectSet(objname, OBJPROP_STYLE, Session_borders_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_borders_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);
      
      //objname = session + " Session High label";
      //ObjectCreate(objname, OBJ_TEXT, 0, time2 - 1800, price2);
      //ObjectSet(objname, OBJPROP_BACK, false);
      //ObjectSetText(objname, DoubleToStr(price2, Digits), font_size - 1, "Tahoma", font_color);

      objname = session + " Session Low";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price1, time2, price1);
      ObjectSet(objname, OBJPROP_COLOR, Aqua);
      ObjectSet(objname, OBJPROP_BACK, false);
      ObjectSet(objname, OBJPROP_STYLE, Session_borders_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_borders_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);
      
      //objname = session + " Session Low label";
      //ObjectCreate(objname, OBJ_TEXT, 0, time2 - 1800, price1);
      //ObjectSet(objname, OBJPROP_BACK, false);
      //ObjectSetText(objname, DoubleToStr(price1, Digits), font_size - 1, "Tahoma", font_color);

      objname = session + " Session Begin";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price2, time1, price1);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_borders_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_borders_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);
      //ObjectSetText(objname, session, font_size, font_name, font_color);

      objname = session + " Session End";
      ObjectCreate(objname, OBJ_TREND, 0, time2, price1, time2, price2);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_borders_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_borders_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);

   }  
}  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
   